	/*
		Simple DirectX 11

		File:		Class_ExamineAdapters.h
		Version:	0.2
		Author:		Nero

		Referenzen:
		http://www.spieleprogrammierer.de/27-tutorials/13263-direct3d11-settings-dialog-teil-1-enumerieren/
	*/
	#pragma once	

	#include <System_Includes.h>
	

	class sdx_E_Adapters
	{
		public:
			sdx_E_Adapters();
		   ~sdx_E_Adapters();

		public:
			HRESULT								ExamineAdapters(DWORD *);

		public:
			HRESULT								sdx_E_Error;

		private:
			IDXGIFactory1				*		sdx_E_Factory;
			vector <IDXGIAdapter1*>				sdx_E_AdapterList;
			vector <IDXGIOutput*>				sdx_E_OutputList;
			vector <DXGI_MODE_DESC>				sdx_E_VideoModeList;
			vector <MSAA>						sdx_E_MSAAList;

			HRESULT								sdx_E_GetAdapterList(void);
			void								sdx_E_ClearAdapterList(void);
			HRESULT								sdx_E_GetOutputList(DWORD);
			void								sdx_E_ClearOutputList(void);
			HRESULT								sdx_E_GetVideoModeList(DWORD);
			void								sdx_E_ClearVideoModeList(void);
			HRESULT								sdx_E_GetMSAAList(DWORD);
			void								sdx_E_ClearMSAAList(void);

			TCHAR								tmpVal[10];
			TCHAR						*		DWORDtoWChar(DWORD Val);
	};