Procedure _ExamineKeyboard()
    DisableDebugger
    Protected retVal = ExamineKeyboard()
    EnableDebugger
    ProcedureReturn retVal
EndProcedure

Procedure _KeyboardPushed(Const.l)
    DisableDebugger
    Protected retVal = KeyboardPushed(Const)
    EnableDebugger
    ProcedureReturn retVal
EndProcedure

Macro ExamineKeyboard()
    _ExamineKeyboard()
EndMacro
  
Macro KeyboardPushed(A)
    _KeyboardPushed(A)
EndMacro
  
  
;/////////////////////////////////////////////////////////////// 
; Diese Procedure dient nur dazu um PB zu sagen welche Libs es mit linken mu
Procedure EXPORT_FUNCTIONS()
  AllocateMemory(0)  
  CreateXML(#PB_Any, #PB_UTF8)  
  MessageRequester("","")
EndProcedure
;/////////////////////////////////////////////////////////////// 


Structure AdapterSettings
  WindowId.l
  AdapterId.l
  OutputId.l
  Width.l
  Height.l
  Nominator.l
  Denominator.l
  MSAACount.l
  MSAAQuality.l
  AnisotropyLvl.l
  FullScreen.b
  VSync.b
  nearView.f      ; standart 1.0
  farView.f       ; standart 100.0  
EndStructure


Import "C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Lib\x86\dxgi.lib" :    EndImport
Import "C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Lib\x86\d3d11.lib" :   EndImport
Import "C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Lib\x86\D3DX10.lib" :  EndImport
Import "C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Lib\x86\D3DX11.lib" :  EndImport
Import "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\lib\msvcrt.lib" :        EndImport
Import "C:\Program Files (x86)\Microsoft Visual Studio 10.0\VC\lib\msvcprt.lib" :       EndImport


Import "G:\libs\SimpleDX11\Release\SimpleDX11.lib"
  InitSimpleDX11() As "_InitSimpleDX11@0"  
  CloseSimpleDX11(*sdxPtr) As "_CloseSimpleDX11@4"  
  SimpleDX11Error(*sdxPtr) As "_SimpleDX11Error@4"
  sdxExamineAdapters(*sdxPtr, *outPtr)  As "_sdxExamineAdapters@8" 
  sdxInitScreen(*sdxPtr, *settings)     As "_sdxInitScreen@8" 
  sdxFreeScreen(*sdxPtr)                As "_sdxFreeScreen@4"
  sdxClearScreen(*sdxPtr, color.l)     As "_sdxClearScreen@8"   ; Color = Hexwert, RGB() oder RGBA() 
  sdxFlipBuffers(*sdxPtr)     As "_sdxFlipBuffers@4" 
  sdxWChartoChar(*sdxPtr, wStr.s) As "_sdxWChartoChar@8"        ; Gibt einen Pointer zu einem neuen CString zurck (kann mit FreeMemory freigegeben werden)
EndImport


;/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



If Not InitKeyboard()
  MessageRequester("Fehler", "Die Tastatur konnte nicht initialisiert werden!")
  End  
EndIf


; Wichtig immer zuerst aufrufen
*sdxPtr = InitSimpleDX11()
If SimpleDX11Error(*sdxPtr)
  End
EndIf


; Anzeige test aller Adapter im System 
*test = NULL
sdxExamineAdapters(*sdxPtr, @*test)
If SimpleDX11Error(*sdxPtr)
  End
EndIf

;   size = ExportXMLSize(*test)
;   XML.s = Space(size)
;   ExportXML(*test, @XML, size)
;   MessageRequester("", XML)
;   FreeXML(*test)


#Window = 0
WID.l
If OpenWindow(#Window, 0, 0, 800, 600,"Test Simple DirectX 11 Screen",#PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_ScreenCentered)
  WID = WindowID(#Window)
Else
  CloseSimpleDX11(*sdxPtr)
  MessageRequester("Fehler", "Fenster konnte nicht geffnet werden!")
  End
EndIf

; Screen settings
Settings.AdapterSettings
Settings\WindowId        = WID
Settings\AdapterId       = 0
Settings\OutputId        = 0
Settings\Width           = WindowWidth(#Window)
Settings\Height          = WindowHeight(#Window)
Settings\MSAACount       = 2
Settings\MSAAQuality     = 4
Settings\Nominator       = 60
Settings\Denominator     = 1
Settings\AnisotropyLvl   = 16
Settings\FullScreen      = #False
Settings\VSync           = #False


sdxInitScreen(*sdxPtr, @Settings) 

*testStr = sdxWChartoChar(*sdxPtr, "TestTestTestTest")
Debug *testStr
Debug PeekS(*testStr, -1, #PB_Ascii)

Repeat
  ExamineKeyboard()
  Event.l = WindowEvent()  
  
   sdxClearScreen(*sdxPtr, $FFB16447)
  
   sdxFlipBuffers(*sdxPtr)
   Delay(1)
 
Until Event = #PB_Event_CloseWindow Or KeyboardPushed(#PB_Key_Escape)

 sdxFreeScreen(*sdxPtr) 




 CloseSimpleDX11(*sdxPtr)
; IDE Options = PureBasic 5.00 Beta 3 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 138
; FirstLine = 93
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; Executable = test.dll