	/*
		Simple DirectX 11

		File:		SimpleDX11.h
		Version:	0.1
		Author:		Nero

		Das ist keine echte PureBasic Userlib es werden nur einige PureBasic Funktionen genutzt
		daher ist es abhngig von PureBasic.

		Referenzen:
		http://www.spieleprogrammierer.de/27-tutorials/13263-direct3d11-settings-dialog-teil-1-enumerieren/
		http://www.directxtutorial.com/Tutorial11/tutorials.aspx
		http://www.rastertek.com/tutdx11.html	
		http://msdn.microsoft.com/en-us/library/windows/desktop/ee663274%28v=vs.85%29.aspx
	*/

	#pragma once

	#include <System_Includes.h>
	#include <Class_ExamineAdapters.h>	
	#include <Class_Direct3D.h>
	#include <Class_Shader.h>

	class SimpleDX11
	{
		public:
			 SimpleDX11(void);
			~SimpleDX11(void);
	
		public:
			HRESULT				sdxError;
			HRESULT				sdxExamineAdapters(DWORD *);
			HRESULT				sdxInitScreen(D3DAdapterSettings *);
			void				sdxFreeScreen(void);
			void				sdxClearScreen(DWORD Color);
			void				sdxFlipBuffers(void);
			HRESULT				sdxCompileShaderFromMemory(TCHAR*, TCHAR*, TCHAR*, TCHAR*, DWORD);
			DWORD*				sdxWChartoChar(TCHAR*);
		private:
			sdx_Direct3D	*	sdxD3D;
			sdx_Shader		*   sdxShader;

	};